<?php
if (!function_exists('add_action')) {
    echo "You called me directly** Smart***";
    exit;
}

class BotManager {

    /**
     *
     * ** */
    private $some_known_Bots = array(
        'googlebot' => 'Googlebot',
        'msnbot' => 'MSNBot',
        'slurp' => 'Inktomi',
        'yahoo' => 'Yahoo',
        'askjeeves' => 'AskJeeves',
        'fastcrawler' => 'FastCrawler',
        'infoseek' => 'InfoSeek',
        'lycos' => 'Lycos',
        'yandex' => 'YandexBot',
        'geohasher' => 'GeoHasher',
        'gigablast' => 'Gigabot',
        'baidu' => 'Baiduspider',
        'spinn3r' => 'Spinn3r',
        "excite" => "Excite",
        "zemanta" => "Zemanta",
        "internet-archive" => "Internet Archive",
        "ezooms" => "Ezooms",
        "plukkie" => "Plukkie",
        "webcrawler" => "webcrawler",
        "dogpile" => "dogpile",
        "wow64" => "wow64",
        "search-info" => "search-info",
        "apple-webkit" => "apple webkit",
        "baiduspider" => "baiduspider",
        "presto" => "presto",
        "bingbot" => "bingbot"

            //add comma seprated bots here
    );
    protected $checkBotMatches = array();

    function __construct($checkbot = TRUE) {
        if ($checkbot) {
            //check if bot request
            $botList = $this->getBotOption();
            if (!$botList) {
                $botList = $this->some_known_Bots;
            }
            $botList = '/(' . implode('|', $botList) . ')/i';
            if (true == isset($_SERVER['HTTP_USER_AGENT'])) {
                $is_bot = preg_match($botList, trim($_SERVER['HTTP_USER_AGENT']), $matches);
                $this->checkBotMatches = $matches;
            }
        }
    }

    public function getBot() {

        //Return matches if any
        return $this->checkBotMatches;
    }

    //isBot() can be used to check if the request is bot request before incrementing the visit count.
    public function isBot() {
        //check if bot request.
        if (count($this->checkBotMatches) > 0) {
            return true;
        }
        return false;
    }

    public function getBotList() {
        return $this->some_known_Bots;
    }

    public function addBotOption() {
        $botList = get_option(JNG_CLOAK_BOT_OPTION);
        if (!$botList)
            add_option(JNG_CLOAK_BOT_OPTION, json_encode($this->some_known_Bots));
    }

    public function getBotOption() {
        $botList = get_option(JNG_CLOAK_BOT_OPTION);
        if ($botList) {
            return json_decode($botList, TRUE);
        }
        return FALSE;
    }

    public function botOptionForm() {
        modal_Dialog_style("400px", "3.5%");
        ?>
        <h2>Excluded Bots</h2>
        <p>Clicks from bots listed below are not tracked for your cloaked links</p>
        <div class="wp--sales-btn-cont ihv-neig bt bt-anchor">
            <a href = "#openModal-add-bots" class="wp-sales-btn">
            <img src="<?php echo JNG_LINK_CLOAK_URL ?>/img/save.jpg"/>
            <?php _e('Add', 'jng_link_cloaker') ?></a> 
            
            <div class="clearfix"></div>
        </div>
        <div class="wp--sales-btn-cont ihv-neig bt">
            
            <a href = "#openModal-delete-bots" class="wp-sales-btn"><?php _e('Delete', 'jng_link_cloaker') ?>
                <img src="<?php echo JNG_LINK_CLOAK_URL ?>/img/delete.jpg"/>
            </a> 
            <div class="clearfix"></div>
        </div>

        <div class="clearfix"></div>

        <form action="admin.php?page=<?php echo JNG_LINK_CLOAK_LANDING ?>" method="post" id="jng-delete-bot-form" style="margin: 10px 0;">
            <input type="hidden" name="<?php echo JNG_HIDDEN ?>" value="delete_selected_bot"/> 
            <div class="chimp-widefat--cont">
                <table class="widefat">
                    <thead>
                        <tr>
                            <th>Bot ID</th>
                            <th colspan="3" class="">Bot Name</th>
                            <th colspan="3" class="">Select</th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php
                        $bot_list = $this->getBotOption();
                        if ($bot_list) {
                            while (list($key, $value) = each($bot_list)) {
                                ?>
                                <tr class="alternate">
                                    <td>
                                        <strong class="row-title">
                                            <?php echo $key; ?><br/>

                                        </strong>
                                    </td>
                                    <td colspan="3">
                                        <?php echo $value ?>
                                    </td>
                                    <td colspan="3">
                                        <input type="checkbox" value="<?php echo $key; ?>" name="super_cloak_selected_bots[]"/>
                                    </td>

                                </tr>
                                <?php
                            }
                        } else {
                            echo "<tr><td colspan='3'>No predefined bolts excluded</td></tr>";
                        }
                        ?>
                    <tbody>
                </table>
            </div>
            <div class="wp--sales-btn-cont ihv-neig bt bt-anchor" style="margin: 10px 0;">
                <img src="<?php echo JNG_LINK_CLOAK_URL ?>/img/save.jpg"/>
                <a href = "#openModal-add-bots" class="wp-sales-btn">
                
                <?php _e('Add', 'jng_link_cloaker') ?></a> 
                <div class="clearfix"></div>
            </div>
            <div class="wp--sales-btn-cont ihv-neig bt" style="margin: 10px;">
                <img src="<?php echo JNG_LINK_CLOAK_URL ?>/img/delete.jpg"/>
                <a href = "#openModal-delete-bots" class="wp-sales-btn"><?php _e('Delete', 'jng_link_cloaker') ?></a> 
                <div class="clearfix"></div>
            </div>

            <div class="clearfix"></div>

            <div id="openModal-delete-bots" class="modalDialog">
                <div>
                    <a href="#close" title="Close" class="close">X</a>
                    <h3>Delete Selected Bots</h3>
                    <p>Do you really want to delete selected bots?</p>
                    <p><input type="submit" value="Yes"  class="button-primary"> &nbsp;&nbsp;&nbsp;<a href="#close" title="No" class="button-primary">No</a></p>

                </div>
            </div>
        </form>
        <style type="text/css">
            #openModal-add-bots div.inner-modal-content {
                height: 420px;

            }

            #openModal-add-bots div form p textarea {
                height: 120px;
                width: 100%;
                margin:auto;
            }
            div.sample_bots{
                border-top: 1px solid #ccc;
                background: #eee;
                text-align: left;
                padding:.5em;
                box-sizing: border-box;
            }
        </style>
        <div id="openModal-add-bots" class="modalDialog">
            <div class="inner-modal-content">

                <form action="admin.php?page=<?php echo JNG_LINK_CLOAK_LANDING ?>" method="post" id="jng-add-bot-form">
                    <input type="hidden" name="<?php echo JNG_HIDDEN ?>" value="add_bots"/> 
                    <a href="#close" title="Close" class="close">X</a>
                    <h3>Add the names of the bots</h3>
                    <p>Ensure every bot is placed on a new line.<br/>Names are case sensitive.</p>
                    <p></p>
                    <p>
                        <textarea   name="new_bots">
                        </textarea>
                    </p>
                    <div class="wp--sales-btn-cont ihv-neig bt" style="margin-bottom:20px;">

                        <input type="submit" value="Add" class="wp-sales-btn">
                        <div class="clearfix"></div>
                    </div>
                    <div class="wp--sales-btn-cont ihv-neig bt bt-anchor">

                        <a href="#close" class="wp-sales-btn"><?php _e('Cancel', 'jng_link_cloaker') ?></a> 
                        <div class="clearfix"></div>
                    </div>

                </form>
                <div class="clearfix"></div>
                <div class="sample_bots">

                    <strong>Example:</strong><br/>
                    Googlebot<br/>
                    MSNBot<br/>
                    Yahoo<br/>
                    <p>
                        Visit <a href="http://www.robotstxt.org/db.html" target="_blank">http://www.robotstxt.org/db.html</a> for a database of robots 
                    </p>
                </div>
            </div>
        </div>
        <?php
    }

    public function delete_selected_bots() {
        //retrieve data from post 
        //if data are submitted, removed them from the bots array and update database
        if (isset($_POST["super_cloak_selected_bots"])) {
            //echo print_r($_POST["super_cloak_selected_bots"]);
            $selected_bots = $_POST["super_cloak_selected_bots"];
            $existing_bots = $this->getBotOption();
            foreach ($selected_bots as $s) {
                unset($existing_bots[trim($s)]);
            }

            $this->updateBotOption($existing_bots);
            $red_link = admin_url("admin.php?page=" . JNG_LINK_CLOAK_EXCLUDE_BOT . "&m=bots_true");
        } else {
            $red_link = admin_url("admin.php?page=" . JNG_LINK_CLOAK_EXCLUDE_BOT . "&m=bots_false");
        }

        wp_redirect($red_link, 301);
        exit;
    }

    public function updateBotOption($bots) {
        update_option(JNG_CLOAK_BOT_OPTION, json_encode($bots));
    }

    public function add_new_bots() {
        //retrieve the new bots
        //form an array from the listed bots
        //iterate through submitted bots and insert into the array only if the key doesn't exists
        $red_link = admin_url("admin.php?page=" . JNG_LINK_CLOAK_EXCLUDE_BOT . "&m=add_bots_false");
        if (isset($_POST["new_bots"])) {
            $new_bots = $_POST["new_bots"];
            if ($new_bots) {
                $new_bots = split("\n", $new_bots);
                $existing_bots = $this->getBotOption();
                foreach ($new_bots as $n) {
                    $n_lower = trim(strtolower($n));
                    if (!array_key_exists($n_lower, $existing_bots)) {
                        $existing_bots[$n_lower] = trim($n);
                    }
                }
                $this->updateBotOption($existing_bots);
                $red_link = admin_url("admin.php?page=" . JNG_LINK_CLOAK_EXCLUDE_BOT . "&m=add_bots_true");
            }
        }
        wp_redirect($red_link, 301);
        exit;
    }

}
