<?php

global $jng_db_version;
$jng_db_version = "1.1.3";

function jng_install_data($table_name, $clicks_table) {
    global $wpdb;
    $link_key = "link_cloaker";
    $link_target = "http://wakapass.com";
    $link_keywords ="the,come,room";

    $rows_affected = $wpdb->insert($table_name, array('link_key' => $link_key, 'link_target' => $link_target,"link_keywords"=>$link_keywords));
    $link_id = $wpdb->insert_id;
    $rows = $wpdb->insert($clicks_table, array('link_id' => $link_id, 'f_date' => date("Y-m-d H:i:s"), 'click_hour' => date("H"),'click_day' => date("d"),'click_week' => date("W"),'click_month' => date("m"),'click_year' => date("Y")));
  
}

function jng_install() {
    global $wpdb;
    global $jng_db_version;

    $table_name = $wpdb->prefix . JNG_REDIRECT_TABLE;
    $clicks_table = $wpdb->prefix . JNG_CLICK_TABLE;
    $main_sql = "CREATE TABLE $table_name (
            id mediumint(11) NOT NULL AUTO_INCREMENT,
            link_key varchar(255) NOT NULL,
            link_target varchar(255) NOT NULL,
            link_views mediumint(11) DEFAULT 0 NOT NULL,
            link_keywords varchar(1000) NULL,
            UNIQUE KEY id (id)
        );";
       $click_sql = "CREATE TABLE $clicks_table (
            id mediumint(11) NOT NULL AUTO_INCREMENT,
            f_date datetime NULL,
            link_clicks mediumint(11) DEFAULT 0 NOT NULL,
            link_views mediumint(11) DEFAULT 0 NOT NULL,
            link_id mediumint(11) NOT NULL,
            click_hour VARCHAR(2) NULL,
            click_day VARCHAR(2) NULL,
            click_week VARCHAR(2) NULL,
            click_month VARCHAR(2) NULL,
            click_year VARCHAR(4) NULL,
            UNIQUE KEY id (id)
          );";

    //Check if plugin has been installed before
    if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta($main_sql);
        dbDelta($click_sql);
        add_option("jng_db_version", $jng_db_version);
        add_option("jng_url_prefix", "get");

        //Add test data
        jng_install_data($table_name, $clicks_table);
    }

    //Upgrade plugin tables if an older installation exists
    $installed_ver = get_option("jng_db_version");
    if ($installed_ver != $jng_db_version) {
        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta($main_sql);
        dbDelta($click_sql);
        update_option("jng_db_version", $jng_db_version);
    }
}



function jng_update_db_check() {
    global $jng_db_version;
    $jng_bot_Manager = new BotManager(FALSE);
    $jng_bot_Manager->addBotOption();
    if (get_site_option('jng_db_version') != $jng_db_version) {
        jng_install();
    }
}

add_action('plugins_loaded', 'jng_update_db_check');
?>
