var superCloak = {}
superCloak.default_format = 'hourly';
superCloak.default_height = 450;
superCloak.default_id = 0;
superCloak.data_array = null;
superCloak.analytics = function(id, chart_format, from, to) {
    jQuery('.ajax-loader').show();
    superCloak.default_id = id;
    jQuery.ajax({
        type: 'POST',
        url: the_ajax_script.ajaxurl,
        data: {
            action: 'analytics_action',
            link_id: id,
            format: chart_format,
            from: from,
            to: to
        },
        success: function(data, textStatus, XMLHttpRequest) {
            data = data.substring(0, data.length - 1);
            //alert(data);
            var data_array = jQuery.parseJSON(data);
            superCloak.data_array = data_array;
            superCloak.chart(data_array, 'all');
            //jQuery("#chart_div").html(data);
            jQuery('.ajax-loader').hide();

        },
        error: function(MLHttpRequest, textStatus, errorThrown) {
            alert(errorThrown);
        }
    });


}
superCloak.refreshSelect = function() {
    var html = '<option value="all">Change display</option>';
    html += '<option value="all">All</option>';
    html += "<option value='ctr'>CTR Only</option>";
    html += "<option value='impressions'>Impressions Only</option>"
    html += "<option value='clicks'>Clicks Only</option>";
    html += "<option value='ctr+impressions'>CTR + Impressions</option>";
    html += "<option value='ctr+clicks'>CTR + Clicks</option>";
    html += "<option value='clicks+impressions'>Clicks + Impressions</option>";
    jQuery('.jng_chart_view').html(html);
}
superCloak.chart = function(data_array, display_type) {
    console.log(data_array);
    data_array['categories'] = data_array['categories'].slice(0, 12);
    data_array['clicks'] = data_array['clicks'].slice(0, 12);
    data_array['ctr'] = data_array['ctr'].slice(0, 12);
    data_array['views'] = data_array['views'].slice(0, 12);
    
    if (!display_type) {
        display_type = 'all';
    }
    var options = {};
    options.chart = {
        renderTo: 'chart_div',
        type: 'line',
        height: superCloak.default_height,
        marginRight: 130,
        marginBottom: 25
    };
    options.title = {
        text: 'Analytics for ' + data_array['title'],
        x: -20 //center
    };
    options.subtitle = {
        text: 'Clicks, Impressions and CTR(%)',
        x: -20
    };
    
    options.xAxis = {
        categories: data_array['categories'],
        labels: {
                rotation: 350,
                step:Math.round((data_array['categories'].length / 7)+1)
            }
    };
    options.yAxis = {
         allowDecimals: false,
         min:0
    };
    options.yAxis.plotLines = [{
            value: 0,
            width: 1,
            color: '#808080'
        }];


    options.tooltip = {
        formatter: function() {
            return '<b>' + this.series.name + ' : ' + this.y + '</b><br/>' +
                    this.x;
        }
    };
    options.legend = {
        layout: 'vertical',
        align: 'right',
        verticalAlign: 'top',
        x: -10,
        y: 100,
        borderWidth: 0
    };
    if (display_type === 'all') {
        options.series = [{
                name: 'Clicks',
                data: data_array['clicks']
            }, {
                name: 'Impressions',
                data: data_array['views']
            }, {
                name: 'CTR',
                data: data_array['ctr']
            }];
        options.yAxis.title = {
            text: 'Clicks,Impressions and CTR(%)'
        };
    } else if (display_type === 'ctr') {
        options.series = [{
                name: 'CTR',
                data: data_array['ctr']
            }];
        options.yAxis.title = {
            text: 'CTR(%)'
        }
    } else if (display_type === 'clicks') {
        options.series = [{
                name: 'Clicks',
                data: data_array['clicks']
            }];
        options.yAxis.title = {
            text: 'Clicks'
        };
    } else if (display_type === 'impressions') {
        options.series = [{
                name: 'Impressions',
                data: data_array['views']
            }];
        options.yAxis.title = {
            text: 'Impressions'
        }
    } else if (display_type === 'ctr+clicks') {
        options.series = [{
                name: 'Clicks',
                data: data_array['clicks']
            }, {
                name: 'CTR',
                data: data_array['ctr']
            }];
        options.yAxis.title = {
            text: 'Clicks and CTR(%)'
        }
    } else if (display_type === 'ctr+impressions') {
        options.series = [{
                name: 'Impressions',
                data: data_array['views']
            }, {
                name: 'CTR',
                data: data_array['ctr']
            }];
        options.yAxis.title = {
            text: 'Impressions and CTR(%)'
        }
    } else if (display_type === 'clicks+impressions') {
        options.series = [{
                name: 'Clicks',
                data: data_array['clicks']
            }, {
                name: 'Impressions',
                data: data_array['views']
            }];
        options.yAxis.title = {
            text: 'Clicks and Impressions'
        }
    }
    chart = new Highcharts.Chart(options);
}
jQuery(document).ready(function() {
    jQuery("#test-nomal").click(function(){
        jQuery("#myModal").modal();
    });
    jQuery('.jng_chart_view').change(function(e) {
        e.preventDefault();
        var display_type = jQuery(this).val();
        superCloak.chart(superCloak.data_array, display_type);
    });
    jQuery('.analytics_link').click(function(e) {
        e.preventDefault();
        var id = jQuery(this).attr('data-id');
        jQuery('.default-format').addClass('jng_active');
        superCloak.analytics(id, superCloak.default_format, '', '');
    });
    jQuery('.jng-format').click(function(e) {
        var format = jQuery(this).attr('data-value');
        superCloak.default_format = format;
        jQuery('.jng-format').removeClass('jng_active');
        jQuery(this).addClass('jng_active');
        var from = jQuery("#jng_from").val();
        var to = jQuery("#jng_to").val();
        superCloak.analytics(superCloak.default_id, format, from, to);
        superCloak.refreshSelect();
        jQuery("#jng_from").val("");
        jQuery("#jng_to").val("");
    });
    jQuery('.range_date').datepicker({
        dateFormat: 'yy-m-d'
    });
    jQuery('.ajax-loader').hide();
    var window_height = jQuery(window).height();
    window_height = 0.9 * 0.65 * window_height;
    if (!(window_height <= 0) && window_height != null && window_height != 'undefined') {
        superCloak.default_height = Math.round(window_height);
    }
    jQuery('#range_btn').click(function(e) {
        var from = jQuery("#jng_from").val();
        var to = jQuery("#jng_to").val();
        superCloak.analytics(superCloak.default_id, superCloak.default_format, from, to);
        jQuery("#jng_from").val("");
        jQuery("#jng_to").val("");
        superCloak.refreshSelect();
    });
});

