<?php

/*
   Plugin Name:WP Sales Chimp Pro
  Plugin URI: http://www.wpsaleschimp.com
  Description: WP Sales Chimp is a weight lifter that makes all your link cloaking effort so easy, flexible and increases your Click Through rate to as high as 200% today
  Version: 1.0
  Author: Jide Neye
  Author URI: http://www.netprofitsimplified.com
  License:
 */

define('JNG_LINK_CLOAK_DIR', plugin_dir_path(__FILE__));
define('JNG_LINK_CLOAK_URL', plugin_dir_url(__FILE__));
define('JNG_LINK_CLOAK_LANDING', "jng-link-redirect");
define('JNG_LINK_CLOAK_ADD', "jng-add-new-redirect");
define('JNG_LINK_CLOAK_ADD_NEW_PREFIX', "jng-add-new-prefix");
define('JNG_LINK_CLOAK_CLEAR_DB', "jng-clear-db");
define('JNG_LINK_CLOAK_EXPORT', "jng-export-csv");
define('JNG_LINK_CLOAK VERSION', '1.0');
define('JNG_REDIRECT_TABLE', 'jng_redirects');
define('JNG_CLICK_TABLE', 'jng_clicks');
define('JNG_VIEWS_TABLE', 'jng_views');
define('JNG_HIDDEN', 'jng_submit_hidden');
define("JNG_DATA_FIELD_NAME", 'jng_url_prefix');
define("JNG_OPTION_NAME", 'jng_url_prefix');//deprecated
define("JNG_URL_PREFIX_OPTION_NAME", 'jng_url_prefix');
define("JNG_UPLOAD_DIRECTORY", "jng_super_cloak");
define("JNG_CLOAK_BOT_OPTION", "jng_cloak_bot_option");
define('JNG_LINK_CLOAK_EXCLUDE_BOT', "jng-exclude-bot");




if (!function_exists('add_action')) {
    echo "You called me directly** Smart***";
    exit;
}
require_once dirname(__FILE__) . '/includes/jng_bots_list.php';
require_once dirname(__FILE__) . '/includes/jng-pop-up-on-exit.php';
if (is_admin()) {
    require_once dirname(__FILE__) . '/includes/jng_installer.php';
    require_once dirname(__FILE__) . '/includes/jng_menu.php';
    require_once dirname(__FILE__) . '/includes/jng_factory.php';
}

//***** Redirection *****
function jng_redirect_link_engine() {
    $jng_botManager = new BotManager();

    global $wpdb;

    if (!isset($_SERVER['REQUEST_URI'])) {
        $get_req = substr($_SERVER['PHP_SELF'], 1);
        if (isset($_SERVER['QUERY_STRING']) AND $_SERVER['QUERY_STRING'] != '') {
            $get_req.='?' . $_SERVER['QUERY_STRING'];
        }
    } else {
        $get_req = $_SERVER['REQUEST_URI'];
    }
    $link_prefix = get_option(JNG_URL_PREFIX_OPTION_NAME);
    if (!$link_prefix) {
        $link_prefix = "get";
    }

    if (strpos('/' . $get_req, '/' . $link_prefix . '/')) {
        $jng_link_key = explode($link_prefix . '/', $get_req);
        $jng_link_key = $jng_link_key[1];
        $jng_link_key = str_replace('/', '', $jng_link_key);
        $jng_link_key = $wpdb->escape($jng_link_key);
        $redirect_table = $wpdb->prefix . JNG_REDIRECT_TABLE;
        $clicks_table = $wpdb->prefix . JNG_CLICK_TABLE;
        $result = $wpdb->get_row("SELECT DISTINCT id,link_target FROM " . $redirect_table . " WHERE link_key = '" . $jng_link_key . "'", ARRAY_A);
        //echo print_r($result).'<br/>';
        //exit;
        if ($result) {

            // echo '<br/>'.print_r($jng_clicked);
            //check if it is a both before doing anything
            if (!$jng_botManager->isBot()) {
                //get the link id
                $jng_id = $result["id"];
                $jng_today = date("Y-m-d H:i:s");
                $jng_hr = date("H");
                $jng_day = date('d');
                $jng_week = date('W');
                $jng_month = date('m');
                $jng_year = date("Y");

                $row_results = $wpdb->insert($clicks_table, array('link_id' => $jng_id, 'f_date' => date("Y-m-d H:i:s"), 'click_hour' => $jng_hr, 'click_day' => $jng_day, 'click_week' => $jng_week, 'click_month' => $jng_month, 'click_year' => $jng_year, 'link_clicks' => 1));
            }

            wp_redirect($result['link_target'], 302);
            exit;
        } else {
            wp_redirect(get_option('siteurl'), 302);
            exit;
        }
    }
}

add_action('init', 'jng_redirect_link_engine'); //Redirect
//Load Script to track user views
//Handle tracking views ajax request

function jng_handle_view_action_callback() {
    global $wpdb;

    if (isset($_POST['id_data'])) {

        $jng_id_data = explode(",", $_POST['id_data']);
        $views_table = $wpdb->prefix . JNG_CLICK_TABLE;
        $jng_today = date("Y-m-d H:i:s");
        $jng_hr = date("H");
        $jng_day = date('d');
        $jng_week = date('W');
        $jng_month = date('m');
        $jng_year = date("Y");
        $link_view = 1;
        $jng_query = "INSERT INTO $views_table(f_date,link_views,link_id,click_hour,click_day,click_week,click_month,click_year) VALUES";

        for ($i = 0; $i < sizeof($jng_id_data); $i++) {
            $jng_query .="('$jng_today',$link_view," . esc_sql($jng_id_data[$i]) . ",'$jng_hr','$jng_day','$jng_week','$jng_month','$jng_year')";
            if ($i != (sizeof($jng_id_data) - 1)) {
                $jng_query .=",";
            }
        }
        $jng_query .= ";";
        //echo "id=" .$jng_id_data[0]." b";
        $row_results = $wpdb->query($jng_query);
    }
}

function jng_handle_analytics_action_callback() {
    //echo $sql;
    //formats - hourly, daily, weekly, monthly
    //  echo 'hourly';
    //fetch clicks grouped by hourly for the date range if given
    //fetch impressions grouped by hourly for the date range if given
    //Calculate CTR from  clicks/views results
    global $wpdb;
    $link_id = trim($_POST['link_id']);
    $format = trim($_POST['format']);
    $from = $_POST['from'];
    $to = $_POST['to'];
    //echo $format." and ";

    $redirect_table = $wpdb->prefix . JNG_REDIRECT_TABLE;
    $clicks_table = $wpdb->prefix . JNG_CLICK_TABLE;
    $sql = "SELECT id,link_key,link_target FROM  $redirect_table WHERE id=$link_id";
    $jng_result = $wpdb->get_row($sql, ARRAY_A);
    $output = array(
            'categories' => array(0),
            'views' => array(0),
            'clicks' => array(0),
            'ctr' => array(0),
            'title' => ''
        );
    $query = '';
    $query = "SELECT click_hour,click_day,click_week,click_month,click_year,SUM(link_views) as link_views,SUM(link_clicks) as link_clicks FROM  $clicks_table WHERE link_id=$link_id";
    if ($from) {
        $query .= " AND f_date >= '" . $from . "'";
    }
    if ($to) {
        $query .= " AND f_date <= '" . $to . "'";
    }
    if ($format == 'yearly') {
        $query .= " GROUP BY click_year ORDER BY f_date";
    } else if ($format == 'monthly') {
        $query .= " GROUP BY click_month,click_year ORDER BY f_date";
    } else if ($format == 'weekly') {
        $query .= " GROUP BY click_week,click_year ORDER BY f_date";
    } else if ($format == 'daily') {
        $query .= " GROUP BY click_day,click_month,click_year ORDER BY f_date";
    } else {
        $query .= " GROUP BY click_hour,click_day,click_month,click_year ORDER BY f_date";
    }
// echo $query;
    $jng_analtytics_data = $wpdb->get_results($query, ARRAY_A);
    $jng_categories_array = array();
    $jng_views_array = array();
    $jng_clicks_array = array();
    $jng_ctr_array = array();

    if ($jng_analtytics_data) {

        foreach ($jng_analtytics_data as $j) {
            if ($format == 'yearly') {
                $jng_categories_array[] = $j['click_year'];
            } else if ($format == 'monthly') {
                $jng_categories_array[] = date("M", mktime(0, 0, 0, $j['click_month'], 10)) . ' ' . $j['click_year'];
            } else if ($format == 'weekly') {
                $jng_categories_array[] = 'Week ' . $j['click_week'] . ', ' . $j['click_year'];
            } else if ($format == 'daily') {
                $jng_categories_array[] = $j['click_year'] . '-' . $j['click_month'] . '-' . $j['click_day'];
            } else {
                $jng_categories_array[] = $j['click_year'] . '-' . $j['click_month'] . '-' . $j['click_day'] . ' ' . $j['click_hour'] . 'hrs';
            }

            $jng_views_array[] = intval($j['link_views']);
            $jng_clicks_array[] = intval($j['link_clicks']);
            $jng_ctr_array[] = $j['link_views'] == 0 ? 0 : floatval(round((($j['link_clicks'] / $j['link_views']) * 100), 2));
        }
        $output = array(
            'categories' => $jng_categories_array,
            'views' => $jng_views_array,
            'clicks' => $jng_clicks_array,
            'ctr' => $jng_ctr_array,
            'title' => isset($jng_result['link_key']) ? $jng_result['link_key'] : ''
        );
    }

    echo json_encode($output);
}

add_action('wp_ajax_analytics_action', 'jng_handle_analytics_action_callback');
add_action('wp_ajax_ajax_action', 'jng_handle_view_action_callback');
add_action('wp_ajax_nopriv_ajax_action', 'jng_handle_view_action_callback');

function app_output_buffer() {
    ob_start();
}

// soi_output_buffer
add_action('init', 'app_output_buffer');

function jng_add_custom_scripts() {

    wp_enqueue_script(
            'bootstrap-modal', plugins_url('/js/bootstrap-modal.js', __FILE__), array('jquery')
    );
    wp_enqueue_script(
            'highchart', plugins_url('/js/highcharts.js', __FILE__)
    );
    wp_enqueue_script(
            'exporting', plugins_url('/js/exporting.js', __FILE__)
    );
    wp_enqueue_script('jquery-ui-datepicker');
    wp_enqueue_script('jquery-ui-tooltips');
    wp_enqueue_script(
            'supercloak_scripts', plugins_url('/js/supercloak_scripts.js', __FILE__), array('highchart', 'jquery')
    );

    wp_enqueue_style('jquery.ui.theme', plugins_url('/css/jquery-ui-1.10.3.custom.min.css', __FILE__));
    wp_enqueue_style('supercloak_css', plugins_url('/css/style.css', __FILE__));
    wp_localize_script('supercloak_scripts', 'the_ajax_script', array('ajaxurl' => admin_url('admin-ajax.php')));
}
function jng_add_view_tracking_scripts(){
    wp_enqueue_script(
            'superCloakTrackView', plugins_url('/js/superCloakTrackView.js', __FILE__), array('jquery')
    );
    wp_localize_script('superCloakTrackView', 'the_ajax_script', array('ajaxurl' => admin_url('admin-ajax.php')));
}

add_action('wp_enqueue_scripts', 'jng_add_view_tracking_scripts');
add_action('admin_enqueue_scripts', 'jng_add_custom_scripts');


